// BonTuner.cpp: CBonTuner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <winsock2.h>
#include <Windows.h>
#include <SetupApi.h>
#include <Malloc.h>
#include <InitGuid.h>
#include <Math.h>
#include "Resource.h"
#include "BonTuner.h"
#include <stdio.h>

#pragma comment(lib, "SetupApi.lib")
#pragma comment(lib, "ws2_32.lib")

#define UDP_PORT_NUM		10
#define UDP_PORT_NO_START	1234
#define BITRATE_CALC_TIME	500		//ms

//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// ~[ebNX
#define MUTEX_NAME			TEXT("BonDriver_UDP")

// MTCY
#define TSDATASIZE			48128			// TSf[^̃TCY

// FIFOobt@ݒ
#define ASYNCBUFFTIME		2											// obt@ = 2b
#define ASYNCBUFFSIZE		( 0x200000 / TSDATASIZE * ASYNCBUFFTIME )	// 16MbpsƂ

#define REQRESERVNUM		16				// 񓯊NGXg\
#define REQPOLLINGWAIT		10				// 񓯊NGXg|[OԊu(ms)

// 񓯊NGXg
#define IORS_IDLE			0x00			// NGXg
#define IORS_BUSY			0x01			// NGXgM	
#define IORS_RECV			0x02			// MAXgA҂

// hCoCX^XGUID(ƂɓĂ̂͂Ȃ񂾂˂c)
DEFINE_GUID( GUID_FRIIO_DRIVER,	0x5a56d255L, 0xe23a, 0x4b4d, 0x8c, 0x78, 0xc2, 0x65, 0x93, 0x0b, 0x6c, 0x68 );


//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

CBonTuner::CBonTuner()
	: m_hMutex(NULL)
	, m_pIoReqBuff(NULL)
	, m_pIoPushReq(NULL)
	, m_pIoPopReq(NULL)
	, m_hPushIoThread(NULL)
	, m_hPopIoThread(NULL)
	, m_hOnStreamEvent(NULL)
	, m_dwCurSpace(0UL)
	, m_dwCurChannel(0UL)
	, m_sock(INVALID_SOCKET)
	, m_fBitRate(0)
{
	m_pThis = this;

	// NeBJZNV
	::InitializeCriticalSection(&m_CriticalSection);

	// Winsock
	WSADATA stWsa;
	WSAStartup(MAKEWORD(2,0),&stWsa);
}

CBonTuner::~CBonTuner()
{
	// JĂꍇ͕
	CloseTuner();

	// NeBJZNV폜
	::DeleteCriticalSection(&m_CriticalSection);

	// WinsockI
	WSACleanup();

	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner()
{
	return SetChannel(0UL,0UL);
}

void CBonTuner::CloseTuner()
{
	// XbhIvZbg
	m_bLoopIoThread = FALSE;

	// CxgJ
	::CloseHandle(m_hOnStreamEvent);
	m_hOnStreamEvent = NULL;	

	// XbhI
	if(m_hPushIoThread){
		if(::WaitForSingleObject(m_hPushIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPushIoThread, 0);
			::OutputDebugString(TEXT("BonDriver: CBonTuner::CloseTuner() ::TerminateThread(m_hPushIoThread)\n"));
			}		

		::CloseHandle(m_hPushIoThread);
		m_hPushIoThread = NULL;
		}

	if(m_hPopIoThread){
		if(::WaitForSingleObject(m_hPopIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPopIoThread, 0);
			::OutputDebugString(TEXT("BonDriver: CBonTuner::CloseTuner() ::TerminateThread(m_hPopIoThread)\n"));
			}		

		::CloseHandle(m_hPopIoThread);
		m_hPopIoThread = NULL;
		}


	// obt@J
	FreeIoReqBuff(m_pIoReqBuff);
	m_pIoReqBuff = NULL;
	m_pIoPushReq = NULL;
	m_pIoPopReq = NULL;
	m_pIoGetReq = NULL;

	// hCoN[Y
	if(m_sock != INVALID_SOCKET){
		closesocket(m_sock);
		m_sock = INVALID_SOCKET;
		}

	// `l
	m_dwCurChannel = 0UL;
	
	// ~[ebNXJ
	if(m_hMutex){
		::ReleaseMutex(m_hMutex);
		::CloseHandle(m_hMutex);
		m_hMutex = NULL;
		}
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	// I`FbN
	if(!m_hOnStreamEvent || !m_bLoopIoThread)return WAIT_ABANDONED;

	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(m_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\ or `[iꂽ
			return (m_bLoopIoThread)? dwRet : WAIT_ABANDONED;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
		}
}

const DWORD CBonTuner::GetReadyCount()
{
	// o\TSf[^擾
	return m_dwReadyReqNum;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE *pSrc = NULL;

	// TSf[^obt@o
	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
			}
		
		return TRUE;
		}
	
	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	if(!m_pIoGetReq)return FALSE;

	// TSf[^obt@o
	if(m_dwReadyReqNum){
		if(m_pIoGetReq->dwState == IORS_RECV){

			// f[^Rs[
			*pdwSize = m_pIoGetReq->dwRxdSize;
			*ppDst = m_pIoGetReq->RxdBuff;

			// obt@ʒui߂
			::EnterCriticalSection(&m_CriticalSection);
			m_pIoGetReq = m_pIoGetReq->pNext;
			m_dwReadyReqNum--;
			*pdwRemain = m_dwReadyReqNum;
			::LeaveCriticalSection(&m_CriticalSection);

			return TRUE;
			}
		else{
			// O
			return FALSE;
			}
		}
	else{
		// o\ȃf[^Ȃ
		*pdwSize = 0;
		*pdwRemain = 0;

		return TRUE;
		}
}

void CBonTuner::PurgeTsStream()
{
	// obt@o\f[^p[W

	::EnterCriticalSection(&m_CriticalSection);
	m_pIoGetReq = m_pIoPopReq;
	m_dwReadyReqNum = 0;
	::LeaveCriticalSection(&m_CriticalSection);
}

void CBonTuner::Release()
{
	// CX^XJ
	delete this;
}

LPCTSTR CBonTuner::GetTunerName(void)
{
	// `[iԂ
	return TEXT("UDP/IPv4");
}

const BOOL CBonTuner::IsTunerOpening(void)
{
	// `[i̎gp̗LԂ(SvZXʂ)
	HANDLE hMutex = ::OpenMutex(MUTEX_ALL_ACCESS, FALSE, MUTEX_NAME);
	
	if(hMutex){
		// Ƀ`[i͊JĂ
		::CloseHandle(hMutex);
		return TRUE;
		}
	else{
		// `[i͊JĂȂ
		return FALSE;
		}
}

LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	// gp\ȃ`[jOԂԂ(IPv6͂܂ĂȂ)
	switch(dwSpace){
		case 0UL :	return TEXT("UDP/IPv4");
	//	case 1UL :	return TEXT("UDP/IPv6");
		default  :	return NULL;		
		}
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	// gp\ȃ`lԂ
	if(dwSpace > 0 || (dwChannel >= UDP_PORT_NUM))return NULL;
	static TCHAR buf[80] = TEXT("");
	wsprintf(buf,TEXT("|[gԍ %d") , UDP_PORT_NO_START + dwChannel);
	return buf;
}

const DWORD CBonTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return m_dwCurSpace;
}

const DWORD CBonTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

const int CBonTuner::SendIoRequest(HANDLE hDevice,const DWORD dwIoCode, const BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize)
{
	// I[v`FbN
	if(hDevice == INVALID_HANDLE_VALUE)return -1;

	// Mpf[^ݒ
	OVERLAPPED OverLapped;
	::ZeroMemory(&OverLapped, sizeof(OverLapped));
	if(!(OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return -1;

	// f[^M
	DWORD dwReturned = 0;
	const BOOL bRet = ::DeviceIoControl(hDevice, dwIoCode, (LPVOID)pTxdData, dwTxdSize, pRxdData, dwRxdSize, &dwReturned, &OverLapped);
	
	// Cxg폜
	::CloseHandle(OverLapped.hEvent);

	// G[AMf[^擾
	if(!bRet){
		if(::GetLastError() != ERROR_IO_PENDING)return -1;
		if(!::GetOverlappedResult(hDevice, &OverLapped, &dwReturned, TRUE))return -1;
		}

	return (int)dwReturned;
}

CBonTuner::AsyncIoReq * CBonTuner::AllocIoReqBuff(const DWORD dwBuffNum)
{
	if(dwBuffNum < 2)return NULL;

	// mۂ
	AsyncIoReq *pNewBuff = new AsyncIoReq [dwBuffNum];
	if(!pNewBuff)return NULL;

	// [NA
	::ZeroMemory(pNewBuff, sizeof(AsyncIoReq) * dwBuffNum);

	// N\z
	DWORD dwIndex;
	for(dwIndex = 0 ; dwIndex < ( dwBuffNum - 1 ) ; dwIndex++){
		pNewBuff[dwIndex].pNext= &pNewBuff[dwIndex + 1];
		}

	pNewBuff[dwIndex].pNext = &pNewBuff[0];

	return pNewBuff;
}

void CBonTuner::FreeIoReqBuff(CBonTuner::AsyncIoReq *pBuff)
{
	if(!pBuff)return;

	// obt@J
	delete [] pBuff;
}

DWORD WINAPI CBonTuner::PushIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;

	DWORD dwLastTime = ::GetTickCount();

//	::OutputDebugString("CBonTuner::PushIoThread() Start!\n");

	// ǉ byMeru(2008/01/22)
	BYTE TxdData[256];
	DWORD dwBufLen;
	CyUSB_IoHeader *pHead = (CyUSB_IoHeader*)TxdData;

	// hCoTSf[^NGXg𔭍s
	while(pThis->m_bLoopIoThread){

		// NGXg҂K薢Ȃǉ
		if(pThis->m_dwBusyReqNum < REQRESERVNUM){

			// hCoTSf[^NGXg𔭍s(UDPȂ̂ŎMv̂)
			dwBufLen = 0;
			if(!pThis->PushIoRequest(pThis->m_sock, IOCTL_ADAPT_SEND_NON_EP0_DIRECT, TxdData, dwBufLen, TSDATASIZE)){
				// G[
				break;
				}

			continue;
			}

		// NGXg҂t̏ꍇ̓EFCg
		::Sleep(REQPOLLINGWAIT);
		}

//	::OutputDebugString("CBonTuner::PushIoThread() End!\n");
	return 0;
}

DWORD WINAPI CBonTuner::PopIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;

	// σNGXg|[OăNGXg
	while(pThis->m_bLoopIoThread){

		// σf[^΃NGXg
		if(pThis->m_dwBusyReqNum){
			
			// NGXg
			if(!pThis->PopIoRequest(pThis->m_sock)){
				// G[
				break;
				}
			}
		}

	return 0;
}

const BOOL CBonTuner::PushIoRequest(SOCKET sock,const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, const DWORD dwRxdSize)
{
	// hCoɔ񓯊NGXg𔭍s

	// I[v`FbN
	if(sock == INVALID_SOCKET)return FALSE;

	// NGXgZbg
	m_pIoPushReq->dwIoCode = dwIoCode;
	m_pIoPushReq->dwTxdSize = dwTxdSize;
	m_pIoPushReq->dwRxdSize = 0;
	if(dwTxdSize)::CopyMemory(m_pIoPushReq->TxdBuff, pTxdData, dwTxdSize);

	// Cxgݒ
	::ZeroMemory(&m_pIoPushReq->OverLapped, sizeof(OVERLAPPED));
	if(!(m_pIoPushReq->OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return FALSE;

	// UDPMvXj_I
	DWORD Flags=0;
	WSABUF wsaBuf;
	wsaBuf.buf = (char*)m_pIoPushReq->RxdBuff;
	wsaBuf.len = sizeof(m_pIoPushReq->RxdBuff);
	if(SOCKET_ERROR==WSARecv(sock,&wsaBuf,1,&m_pIoPushReq->dwRxdSize,&Flags,(LPWSAOVERLAPPED)&m_pIoPushReq->OverLapped,NULL)){
		int sock_err = WSAGetLastError();
		if(sock_err != ERROR_IO_PENDING){
			return FALSE;
			}
		}

	m_pIoPushReq->dwState = IORS_BUSY;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPushReq = m_pIoPushReq->pNext;
	m_dwBusyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	return TRUE;
}

const BOOL CBonTuner::PopIoRequest(SOCKET sock)
{
	// 񓯊NGXg
	
	// I[v`FbN
	if(sock == INVALID_SOCKET)return FALSE;
	
	// ԃ`FbN
	if(m_pIoPopReq->dwState != IORS_BUSY){
		// O
		return TRUE;
		}

	// NGXg擾
	DWORD Flags=0;
	const BOOL bRet = ::WSAGetOverlappedResult(sock, &m_pIoPopReq->OverLapped, &m_pIoPopReq->dwRxdSize, FALSE,&Flags);

	// G[`FbN
	if(!bRet){
		int sock_err = WSAGetLastError();
		if(sock_err == ERROR_IO_INCOMPLETE){
			// 
			::Sleep(REQPOLLINGWAIT);
			return TRUE;
			}
		}

	// MTCYZ
	m_u64RecvBytes += m_pIoPopReq->dwRxdSize;

	// rbg[gvZ
	if(GetTickCount()-m_dwLastCalcTick>BITRATE_CALC_TIME) CalcBitRate();

	// Cxg폜
	::CloseHandle(m_pIoPopReq->OverLapped.hEvent);

	if(!bRet){
		// G[
		return FALSE;
		}

	m_pIoPopReq->dwState = IORS_RECV;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPopReq = m_pIoPopReq->pNext;
	m_dwBusyReqNum--;
	m_dwReadyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	// CxgZbg
	::SetEvent(m_hOnStreamEvent);

	return TRUE;
}


// `lݒ(M`lꍆ̓rbNGfBA)
const BOOL CBonTuner::SetChannel(const BYTE bCh)
{
	return SetChannel((DWORD)0,(DWORD)bCh-13);
}

// `lݒ(M`lꍆ̓rbNGfBA)
const BOOL CBonTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// Lȃ`l
	if(!EnumChannelName(dwSpace,dwChannel)) return FALSE;

	// UN[Y
	CloseTuner();

	// obt@m
	if(!(m_pIoReqBuff = AllocIoReqBuff(ASYNCBUFFSIZE))){
		return FALSE;
		}

	// obt@ʒu
	m_pIoPushReq = m_pIoReqBuff;
	m_pIoPopReq = m_pIoReqBuff;
	m_pIoGetReq = m_pIoReqBuff;
	m_dwBusyReqNum = 0;
	m_dwReadyReqNum = 0;

	try{
		// hCoI[v
		m_sock = socket(AF_INET,SOCK_DGRAM,0);
		if(m_sock==INVALID_SOCKET) throw 1UL;

		// Bind
		WORD wPort = UDP_PORT_NO_START+(WORD)dwChannel;
		struct sockaddr_in stAddr;
		stAddr.sin_family = dwSpace==0 ? AF_INET : AF_INET6;
		stAddr.sin_port = htons(wPort);
		stAddr.sin_addr.S_un.S_addr = INADDR_ANY;
		if(SOCKET_ERROR==bind(m_sock, (struct sockaddr *)&stAddr, sizeof(stAddr)))throw 1UL;

		// Cxg쐬
		if(!(m_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL)))throw 2UL;

		// XbhN
		DWORD dwPushIoThreadID = 0UL, dwPopIoThreadID = 0UL;
		m_hPushIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PushIoThread, this, CREATE_SUSPENDED, &dwPopIoThreadID);
		m_hPopIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PopIoThread, this, CREATE_SUSPENDED, &dwPushIoThreadID);

		if(!m_hPushIoThread || !m_hPopIoThread){
			if(m_hPushIoThread){
				::TerminateThread(m_hPushIoThread, 0UL);
				::CloseHandle(m_hPushIoThread);
				m_hPushIoThread = NULL;
				}

			if(m_hPopIoThread){
				::TerminateThread(m_hPopIoThread, 0UL);
				::CloseHandle(m_hPopIoThread);
				m_hPopIoThread = NULL;
				}

			throw 3UL;
			}

		// XbhJn
		m_bLoopIoThread = TRUE;
		if(::ResumeThread(m_hPushIoThread) == 0xFFFFFFFFUL || ::ResumeThread(m_hPopIoThread) == 0xFFFFFFFFUL)throw 4UL;

		// ~[ebNX쐬
		if(!(m_hMutex = ::CreateMutex(NULL, TRUE, MUTEX_NAME)))throw 5UL;
		}
	catch(const DWORD dwErrorStep){
		// G[
		TCHAR szDebugOut[1024];
		::wsprintf(szDebugOut, TEXT("BonDriver_UDP: CBonTuner::OpenTuner() dwErrorStep = %lu\n"), dwErrorStep);
		::OutputDebugString(szDebugOut);

		CloseTuner();
		return FALSE;
		}

	// `lXV
	m_dwCurSpace = dwSpace;
	m_dwCurChannel = dwChannel;

	// TSf[^p[W
	PurgeTsStream();

	return TRUE;
}

// Mx(rbg[g)擾
const float CBonTuner::GetSignalLevel(void)
{
	CalcBitRate();
	return m_fBitRate;
}

void CBonTuner::CalcBitRate()
{
	DWORD dwCurrentTick=GetTickCount();
	if(m_u64RecvBytes<m_u64LastCalcByte){
		m_u64LastCalcByte = m_u64RecvBytes = 0;
		return;
		}
	if(dwCurrentTick>m_dwLastCalcTick){
		if(dwCurrentTick-m_dwLastCalcTick>BITRATE_CALC_TIME){
			double dTick = (double)(dwCurrentTick-m_dwLastCalcTick) / 1000.0;
			ULONGLONG u64Size = m_u64RecvBytes - m_u64LastCalcByte;
			m_fBitRate = (float)((u64Size / dTick) / 1024 / 1024 * 8.0);
			m_u64LastCalcByte = m_u64RecvBytes;
			m_dwLastCalcTick = dwCurrentTick;
			}
		} else {
			m_dwLastCalcTick = dwCurrentTick;
		}
	return;
}