// BonTuner.h: CBonTuner NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_BONTUNER_H_)
#define _BONTUNER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "IBonDriver2.h"
#include "USBIO.h"

#define BONTYPE_UNKNOWN		0x00	// s
#define BONTYPE_WHITE		0x01	// (ISDB-T)
#define BONTYPE_BLACK		0x02	// (ISDB-S)
#define BONTYPE_RED			0x03	// (ISDB-T/ISDB-SôIH)
#define BONTYPE_GRAY		0x01	// D(RĊDɂȂƂȂȂƂIH)

class CBonTuner : public IBonDriver2
{
public:
	CBonTuner();
	virtual ~CBonTuner();

// IBonDriver
	const BOOL OpenTuner(void);
	void CloseTuner(void);

	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);

	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);

	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);

	void PurgeTsStream(void);

// IBonDriver2(b)
	LPCTSTR GetTunerName(void);

	const BOOL IsTunerOpening(void);
	
	LPCTSTR EnumTuningSpace(const DWORD dwSpace);
	LPCTSTR EnumChannelName(const DWORD dwSpace, const DWORD dwChannel);

	const BOOL SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	
	const DWORD GetCurSpace(void);
	const DWORD GetCurChannel(void);

	void Release(void);

	static CBonTuner * m_pThis;
	static HINSTANCE m_hModule;

protected:
	// I/ONGXgL[f[^
	struct AsyncIoReq
	{
		OVERLAPPED OverLapped;
		DWORD dwState;
		DWORD dwIoCode;
		DWORD dwTxdSize;
		DWORD dwRxdSize;
		BYTE TxdBuff[64];
		BYTE RxdBuff[48128];
		AsyncIoReq *pNext;
	};

	const int SendIoRequest(HANDLE hDevice,const DWORD dwIoCode, const BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize);

	AsyncIoReq * AllocIoReqBuff(const DWORD dwBuffNum);
	void FreeIoReqBuff(AsyncIoReq *pBuff);

	static DWORD WINAPI PushIoThread(LPVOID pParam);
	static DWORD WINAPI PopIoThread(LPVOID pParam);

	const BOOL PushIoRequest(SOCKET sock,const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, const DWORD dwRxdSize);
	const BOOL PopIoRequest(SOCKET );

	HANDLE m_hMutex;

	BYTE m_TxdBuff[256];
	BYTE m_RxdBuff[256];

	AsyncIoReq *m_pIoReqBuff;
	AsyncIoReq *m_pIoPushReq;
	AsyncIoReq *m_pIoPopReq;
	AsyncIoReq *m_pIoGetReq;

	DWORD m_dwBusyReqNum;
	DWORD m_dwReadyReqNum;

	HANDLE m_hPushIoThread;
	HANDLE m_hPopIoThread;
	BOOL m_bLoopIoThread;

	HANDLE m_hOnStreamEvent;

	CRITICAL_SECTION m_CriticalSection;
	
	DWORD m_dwCurSpace;
	DWORD m_dwCurChannel;

	// ǉ byMeru(2008/03/27)
	SOCKET m_sock;
	float m_fBitRate;

	void CalcBitRate();
	ULONGLONG m_u64RecvBytes;
	DWORD m_dwLastCalcTick;
	ULONGLONG m_u64LastCalcByte;
};

#endif // !defined(_BONTUNER_H_)
