// Usbio.h: Cypress CyUsb.sysDeviceIoControlɊւf[^`
//   ^[QbgfoCX̓gGfBA{
//   friiodtv.sysCyUSB.syshCopĂ̂قڊm
//  ǉ byMeru(2008/01/21)
//////////////////////////////////////////////////////////////////////

#if !defined(_USBIO_H_)
#define _USBIO_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Rg[R[h
#define IOCTL_ADAPT_GET_DRIVER_VERSION			0x00220000
#define IOCTL_ADAPT_GET_USBDI_VERSION			0x00220004
#define IOCTL_ADAPT_GET_ALT_INTERFACE_SETTING	0x00220008
#define IOCTL_ADAPT_SELECT_INTERFACE			0x0022000C
#define IOCTL_ADAPT_GET_ADDRESS					0x00220010
#define IOCTL_ADAPT_GET_NUMBER_ENDPOINTS		0x00220014
#define IOCTL_ADAPT_GET_DEVICE_POWER_STATE		0x00220018
#define IOCTL_ADAPT_SET_DEVICE_POWER_STATE		0x0022001C
#define IOCTL_ADAPT_SEND_EP0_CONTROL_TRANSFER	0x00220020
#define IOCTL_ADAPT_SEND_NON_EP0_TRANSFER		0x00220024
#define IOCTL_ADAPT_CYCLE_PORT					0x00220028
#define IOCTL_ADAPT_RESET_PIPE					0x0022002C
#define IOCTL_ADAPT_RESET_PARENT_PORT			0x00220030
#define IOCTL_ADAPT_GET_TRANSFER_SIZE			0x00220034
#define IOCTL_ADAPT_SET_TRANSFER_SIZE			0x00220038
#define IOCTL_ADAPT_GET_DEVICE_NAME				0x0022003C
#define IOCTL_ADAPT_GET_FRIENDLY_NAME			0x00220040
#define IOCTL_ADAPT_ABORT_PIPE					0x00220044
#define IOCTL_ADAPT_SEND_NON_EP0_DIRECT			0x0022004B
#define IOCTL_ADAPT_GET_DEVICE_SPEED			0x0022004C
#define IOCTL_ADAPT_GET_CURRENT_FRAME			0x00220050

// NGXg^Cv
#define REQTYPE_TO_DEVICE	0x00
#define REQTYPE_TO_HOST		0x80
#define REQTYPE_STANDARD	0x00
#define REQTYPE_CLASS		0x20
#define REQTYPE_VENDOR		0x40
#define REQTYPE_OTHER		0x08
#define REQTYPE_ENDPOINT	0x04
#define REQTYPE_INTERFACE	0x02
#define REQTYPE_DEVICE		0x01

// ^CAEg
#define CYUSB_DEFAULT_TIMEOUT	0x00000005
#define CYUSB_VENDOR_TIMEOUT	0x0000000A

#pragma pack(push,1)
// CyUSB IOwb_(̃wb_̒Ƀf[^)
struct CyUSB_IoHeader
{
	UCHAR ucRequestType;		/* B7   : 0=Host to Device / 1=Device to Host */
								/* B6B5 : 00=WNGXg / 01=NXNGXg / 10=x_[NGXg / 11=\ */
								/* B4   : \ */
								/* B3   : ̑ */
								/* B2   : Gh|Cg */
								/* B1   : C^[tF[X */
								/* B0   : foCX */
	UCHAR ucRequestNo;			/* NGXgԍ */
	WORD  wValue;				/* NGXgl */
	WORD  wIndex;				/* CfbNX */
	WORD  wLength;				/*  */
	DWORD dwTimeout;			/* ^CAEg */
	UCHAR reserved;				/*  */
	UCHAR ucEndpointAddress;	/*  */
	DWORD dwNTStatus;			/*  */
	DWORD dwUsbStatus;			/*  */
	DWORD dwIsoPacketOffset;	/*  */
	DWORD dwIsoPacketLength;	/*  */
	DWORD dwBufferOffset;		/* dataւ̃ItZbg */
	DWORD dwBufferLength;		/* data */
};

struct CyUSB_SetTransferInfo
{
	UCHAR ucEndpointAddress;
	DWORD dwTransferSize;
};

//////////////////////////////////////////////////////////////////////
// Descriptor
struct CyUSB_DescriptorHeader
{
	UCHAR ucDescriptorLength;	/* DescriptorS̒ */
	UCHAR ucDescriptorType;		/* Descriptor^Cv */
};

// DeviceDescriptor
struct CyUSB_DeviceDescriptor
{
	struct CyUSB_DescriptorHeader stHead;	/* Type=0x01Œ Len=0x12 */
	WORD  wSpecRelease;						/* USB[Xԍ 0x0200=USB2.0 */ 
	UCHAR ucDeviceClass;					/* NX 0x00=NXȂ*/
	UCHAR ucDeviceSubClass;					/* TuNX 0x00=TuNXȂ*/
	UCHAR ucDeviceProtocol;					/* vgR 0x00=ŗLvgRȂ */
	UCHAR ucMaxPacketSize;					/* Gh|CgO̍őpPbgTCY */
	WORD  wVenderID;						/* x_ID */ 
	WORD  wProductID;						/* v_NgID */ 
	WORD  wDeviceRelease;					/* [Xԍ */ 
	UCHAR ucManufacturer;					/* (StringDescriptor̃CfbNX) */
	UCHAR ucProduct;						/* i(StringDescriptor̃CfbNX) */
	UCHAR ucSerialNumber;					/* ԍ(StringDescriptor̃CfbNX) */
	UCHAR ucNumberConfigurations;			/* Configuration̐ */ 
};

// StringDescriptor
struct CyUSB_StringDescriptor
{
	struct CyUSB_DescriptorHeader stHead;	/* Type=0x03Œ Len=s */
	WCHAR  *szString;						/* Unicode */
};

// ConfigurationDescriptor
struct CyUSB_ConfigurationDescriptor
{
	struct CyUSB_DescriptorHeader stHead;	/* Type=0x02Œ Len=0x09Œ */
	WORD wTotalLength;						/* 㑱Descriptor܂߂S̒ */
	UCHAR ucNumInterface;					/* C^[tF[X̐ */
	UCHAR ucConfigurationValue;				/* Configuration̔ԍ */
	UCHAR ucConfiguration;					/* Configuration(StringDescriptor̃CfbNX) */
	UCHAR ucAttributes;						/*  D7=1 / D6=SelfPower / D5=RemoteWakeup / D4-D0=\(0Œ) */
	UCHAR ucMaxPower;						/* d͂̔(mA) :FA=500mA,64=100mA */
};

// InterfaceDescriptor
struct CyUSB_InterfaceDescriptor
{
	struct CyUSB_DescriptorHeader stHead;	/* Type=0x04Œ Len=0x09Œ */
	UCHAR ucInterfaceNumber;				/* ̃C^[tF[X̃CfbNXԍ(0) */
	UCHAR ucAlternateSetting;				/* SetInterfaceő֐ݒw肷ԍ */
	UCHAR ucNumEndpoints;					/* Gh|Cg */
	UCHAR ucInterfaceClass;					/* NX 0x00=NXȂ 0xFF=x_ŗL */
	UCHAR ucInterfaceSubclass;				/* TuNX 0x00=NXȂ */
	UCHAR ucInterfaceProtocol;				/* vgR 0x00=NXȂ */
	UCHAR ucInterface;						/* C^[tF[X(StringDescriptor̃CfbNX) */
};

// InterfaceDescriptor
struct CyUSB_EndpointDescriptor
{
	struct CyUSB_DescriptorHeader stHead;	/* Type=0x05Œ Len=0x07Œ */
	UCHAR ucEndpointAddress;				/* EndpointAhX */
	UCHAR ucAttributes;						/* 
												D1-D0 ][h 00=Rg[ 01=AC\NiX 10=oN 11=荞
												D5-D2 AC\NiX]p
												D3-D2 [h 00=Ȃ 01=Ȃ 10=A_veBu 11=
												D5-D4 Usage[h 00=f[^ 11=tB[hobN 10=]ItB[hobN? 11=\
											*/
	WORD  wMaxPacketSize;					/* őpPbgTCY */
	UCHAR ucInterval;						/* |[OԊu 0x00=Ȃ*/
};
#pragma pack(pop)

#endif // !defined(_USBIO_H_)
